## simavr 1.5+dfsg1

=== Makefile ===
# Makefile

# Normal build will link against the shared library for simavr
# in the current build tree, so you don't have to 'install' to
# run simavr or the examples.
#
# For package building, you will need to pass RELEASE=1 to make
RELEASE	?= 0

.PHONY: doc

all:	build-simavr build-tests build-examples

build-simavr:
	$(MAKE) -C simavr RELEASE=$(RELEASE)

build-tests: build-simavr
	$(MAKE) -C tests RELEASE=$(RELEASE)

build-examples: build-simavr
	$(MAKE) -C examples RELEASE=$(RELEASE)

install:
	$(MAKE) -C simavr install RELEASE=$(RELEASE)

doc:
	$(MAKE) -C doc RELEASE=$(RELEASE)

clean:
	$(MAKE) -C simavr clean
	$(MAKE) -C tests clean
	$(MAKE) -C examples clean
	$(MAKE) -C doc clean

=== simavr/Makefile ===
#
# 	Copyright 2008-2012 Michel Pollet <buserror@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

SHELL 			:= ${shell which bash}
SIMAVR_VERSION	:= ${shell \
	{ git log -1 --tags --simplify-by-decoration --pretty="format:%d"|\
		sed -e 's/[\(\) ]//g'; } || \
	echo "unknown" }
SIMAVR_REVISION	= 2

target	= run_avr

CFLAGS	+= -Werror
# tracing is useful especialy if you develop simavr core.
# it otherwise eat quite a bit of few cycles, even disabled
#CFLAGS	+= -DCONFIG_SIMAVR_TRACE=1

all:
	$(MAKE) obj config
	$(MAKE) libsimavr ${target}

include ../Makefile.common

cores	:= ${wildcard cores/*.c}
sim		:= ${wildcard sim/sim_*.c} ${wildcard sim/avr_*.c}
sim_o 	:= ${patsubst sim/%.c, ${OBJ}/%.o, ${sim}}

VPATH	= cores
VPATH	+= sim

IPATH	+= sim
IPATH	+= .
IPATH	+= ../../shared

#
# Static library
#
${OBJ}/libsimavr.a	:	${sim_o}
ifeq ($(V),1)
	$(AR) cru $@ $^ && $(RANLIB) $@
else
	@echo AR $@
	@$(AR) cru $@ $^ && $(RANLIB) $@
endif

#
# Shared library (Linux)
#
${OBJ}/libsimavr.so.1	:	${sim_o}
ifeq ($(V),1)
	$(CC) -shared -Wl,-soname,libsimavr.so.1 -o $@ $^ ${filter-out -lsimavr, $(LDFLAGS)}
else
	@echo SHARED $@
	@$(CC) -shared -Wl,-soname,libsimavr.so.1 -o $@ $^ ${filter-out -lsimavr, $(LDFLAGS)}
endif

${OBJ}/libsimavr.so		: ${OBJ}/libsimavr.so.1
	ln -sf libsimavr.so.1 $@

libsimavr	: config ${OBJ}/libsimavr.a
# shared library won't work that easily on non-linux
ifeq (${shell uname}, Linux)
libsimavr	:	${OBJ}/libsimavr.so
endif

${OBJ}/${target}.elf	: ${OBJ}/${target}.o

${target}	: ${OBJ}/${target}.elf

# FIXME uname -o doesn't work on BSD
#ifeq (${shell uname -o}, Msys)
#	ln -sf $< $@.exe
#else
	ln -sf $< $@
#endif

clean: clean-${OBJ}
	rm -rf ${target} *.a *.so *.exe
	rm -f sim_core_*.h

DESTDIR = /usr/local
PREFIX = ${DESTDIR}

install : all
	$(MKDIR) $(DESTDIR)/include/simavr/avr
	$(INSTALL) -m644 sim/*.h $(DESTDIR)/include/simavr/
	$(INSTALL) -m644 sim_core_*.h $(DESTDIR)/include/simavr/
	$(INSTALL) -m644 sim/avr/*.h $(DESTDIR)/include/simavr/avr/
	$(MKDIR) $(DESTDIR)/lib
	$(INSTALL) ${OBJ}/libsimavr.a $(DESTDIR)/lib/
	$(MKDIR) $(DESTDIR)/lib/pkgconfig/
	sed -e "s|PREFIX|${PREFIX}|g" -e "s|VERSION|${SIMAVR_VERSION}|g" \
		simavr-avr.pc >$(DESTDIR)/lib/pkgconfig/simavr-avr.pc
	sed -e "s|PREFIX|${PREFIX}|g" -e "s|VERSION|${SIMAVR_VERSION}|g" \
		simavr.pc >$(DESTDIR)/lib/pkgconfig/simavr.pc
ifeq (${shell uname}, Linux)
	$(INSTALL) ${OBJ}/libsimavr.so.1 $(DESTDIR)/lib/
	ln -sf libsimavr.so.1 $(DESTDIR)/lib/libsimavr.so
endif
	$(MKDIR) $(DESTDIR)/bin
	$(INSTALL) ${OBJ}/${target}.elf $(DESTDIR)/bin/simavr

# Needs 'fpm', oneline package manager. Install with 'gem install fpm'
# This generates 'mock' debian files, without all the policy, scripts
# and all the things normal debian requires. If debian decides to roll
# in simavr officialy, this section shall diseapear
debian:
	rm -rf /tmp/simavr-tmp && mkdir -p /tmp/simavr-tmp/usr && \
	make cleam; make install DESTDIR=/tmp/simavr-tmp/usr RELEASE=1 && \
	(cd /tmp/simavr-tmp && \
	fpm -s dir -t deb -C /tmp/simavr-tmp -n libsimavr -v $(SIMAVR_VERSION) \
		--iteration $(SIMAVR_REVISION) \
		-d 'libelf' \
        --description "lean and mean Atmel AVR simulator: Runtime library" \
        usr/lib/lib*.so* && \
	fpm -s dir -t deb -C /tmp/simavr-tmp -n libsimavr-dev -v $(SIMAVR_VERSION) \
		--iteration $(SIMAVR_REVISION) \
		-d 'libsimavr >= $(SIMAVR_VERSION)' \
        --description "lean and mean Atmel AVR simulator: Development files" \
        usr/include usr/lib/lib*.a usr/lib/pkgconfig && \
	fpm -s dir -t deb -C /tmp/simavr-tmp -n simavr -v $(SIMAVR_VERSION) \
		--iteration $(SIMAVR_REVISION) \
		-d 'libsimavr >= $(SIMAVR_VERSION)' \
        --description "lean and mean Atmel AVR simulator: Executable" \
        usr/bin ) && \
	echo Done

config: ${OBJ}/cores.deps sim_core_config.h sim_core_decl.h

#
# this tries to preprocess all the cores and decide
# which ones have a chance of compiling at all. Some platform
# ship with old version of avr-gcc and associated and needs
# to be verified
#
ifeq ($(V), 1)
DEBUGLOG=/tmp/simavr_conf.log
else
DEBUGLOG=/dev/null
endif
sim_core_config.h ${OBJ}/cores.deps: $(cores) Makefile
	@echo CONF $@
	@conf=""; decl=""; array=""; \
	mkdir -p ${OBJ} ; echo >${OBJ}/cores.deps ; echo >$(DEBUGLOG) ;\
	for core in cores/*.c ; do \
		file=$$core; global=$${core/cores\/sim_}; global=$${global/.c}; \
		upper=$$(echo $$global|tr '[a-z]' '[A-Z]'); \
		if $(CC) -E $(CFLAGS) ${AVR_CPPFLAGS} $$file \
			>>$(DEBUGLOG) 2>&1 ; then \
			conf+="#define CONFIG_$$upper 1\n"; \
			obj=$${file/.c/.o} ; obj=$${obj/cores\/}; \
			printf "\$${OBJ}/libsimavr.a: \$${OBJ}/$$obj\n">>${OBJ}/cores.deps ; \
			printf "\$${OBJ}/libsimavr.so.1: \$${OBJ}/$$obj\n">>${OBJ}/cores.deps ; \
		else \
			echo WARNING $$file did not compile, check your avr-gcc toolchain; \
		fi \
	done ; \
	( printf "// Autogenerated do not edit\n"; \
	  printf "#ifndef __SIM_CORE_CONFIG_H__\n#define __SIM_CORE_CONFIG_H__\n\n"; \
	  printf "#define CONFIG_SIMAVR_VERSION \"${SIMAVR_VERSION}\"\n"; \
	  printf "$$conf\n"; \
	  printf "#endif\n"; \
	) >sim_core_config.h

#
# This take the config file that was generated, and create the static
# table of all available cores for name lookups, as well as a C
# config file
#
sim_core_decl.h: sim_core_config.h $(cores) Makefile
	@echo CONF $@
	@decl=""; array=""; \
	for core in $$(grep -r avr_kind_t cores/|awk -F '[ :]' '{print $$1 "=" $$3;}') ; do \
		file=$${core/=*}; global=$${core/*=}; \
		upper=$$global; upper=$${upper/.c}; \
		upper=$$(echo $$upper|tr '[a-z]' '[A-Z]'); \
		decl+="#if CONFIG_$$upper\nextern avr_kind_t $$global;\n#endif\n"; \
		array+="#if CONFIG_$$upper\n\t&$$global,\n#endif\n"; \
	done ; \
	( printf "// Autogenerated do not edit\n"; \
	  printf "#ifndef __SIM_CORE_DECL_H__\n#define __SIM_CORE_DECL_H__\n\n"; \
	  printf "#include \"sim_core_config.h\"\n";\
	  printf "$$decl\n" ;  \
	  printf "extern avr_kind_t * avr_kind[];\n"; \
	  printf "#ifdef AVR_KIND_DECL\navr_kind_t * avr_kind[] = {\n$$array\tNULL\n};\n#endif\n"; \
	  printf "#endif\n"; \
	) >sim_core_decl.h

-include ${OBJ}/cores.deps

=== examples/board_ds1338/Makefile ===
#	Copyright 2014 Doug Szumski <d.s.szumski@gmail.com>
#	Copyright 2008-2011 Michel Pollet <buserror@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

target=	ds1338demo
firm_src = ${wildcard at*${board}.c}
firmware = ${firm_src:.c=.axf}
simavr = ../../

IPATH = .
IPATH += ../parts
IPATH += ${simavr}/include
IPATH += ${simavr}/simavr/sim

VPATH = .
VPATH += ../parts

LDFLAGS += -lpthread

all: obj atmega32_ds1338.axf ${target}

atmega32_ds1338.axf: atmega32_ds1338.c ds1338.c twimaster.c

include ${simavr}/Makefile.common

board = ${OBJ}/${target}.elf

${board} : ${OBJ}/ac_input.o
${board} : ${OBJ}/ds1338_virt.o
${board} : ${OBJ}/${target}.o

${target}: ${board}
	@echo $@ done

clean: clean-${OBJ}
	rm -rf *.hex *.a *.axf ${target} *.vcd .*.swo .*.swp .*.swm .*.swn

=== examples/board_ssd1306/Makefile ===
# 
# 	Copyright 2008-2011 Michel Pollet <buserror@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

target=	ssd1306demo
firm_src = ${wildcard at*${board}.c}
firmware = ${firm_src:.c=.axf}
simavr = ../../

IPATH = .
IPATH += ../parts
IPATH += ${simavr}/include
IPATH += ${simavr}/simavr/sim
IPATH += ${simavr}/simavr/sim
IPATH += ${simavr}/simavr/sim

VPATH = .
VPATH += ../parts

LDFLAGS += -lpthread

include ../Makefile.opengl

all: obj atmega32_ssd1306.axf ${target}

atmega32_ssd1306.axf: atmega32_ssd1306.c ssd1306.c images.c

include ${simavr}/Makefile.common

board = ${OBJ}/${target}.elf

${board} : ${OBJ}/ac_input.o
${board} : ${OBJ}/ssd1306_virt.o
${board} : ${OBJ}/ssd1306_glut.o
${board} : ${OBJ}/${target}.o

${target}: ${board}
	@echo $@ done

clean: clean-${OBJ}
	rm -rf *.hex *.a *.axf ${target} *.vcd .*.swo .*.swp .*.swm .*.swn

=== debian/changelog ===
simavr (1.5+dfsg1-2) sid; urgency=medium

  * simavr/Makefile:
     + always link to shared library
     + sort the auto generated header files content
  * debian/control: add package maintenance git repository
  * do not hide compiler flags
  * bump standards version up to 4.1.1

 -- Milan Kupcevic <milan@debian.org>  Mon, 27 Nov 2017 22:51:47 -0500

simavr (1.5+dfsg1-1) sid; urgency=medium

  * Initial release. (Closes: #568156)

 -- Milan Kupcevic <milan@debian.org>  Sat, 30 Sep 2017 23:11:30 -0400

=== debian/control ===
Source: simavr
Section: electronics
Priority: optional
Maintainer: Milan Kupcevic <milan@debian.org>
Build-Depends:
 debhelper (>= 10),
 libelf-dev,
 freeglut3-dev,
 pkg-config,
 avr-libc,
 ruby,
 exuberant-ctags,
 graphviz
Standards-Version: 4.1.1
Vcs-Git: https://gitlab.com/debian/simavr.git
Vcs-Browser: https://gitlab.com/debian/simavr.git
Homepage: https://github.com/buserror/simavr

Package: simavr
Architecture: any
Multi-Arch: foreign
Recommends: gtkwave, gdb-avr
Suggests: avr-libc, avra, libsimavr-dev
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: lean and mean AVR simulator
 A simple command line tool using AVR simulator library to run AVR firmware, 
 produce VCD waveform files and/or run a debugging session. The tool reads
 simulation parameters directly from the emulated code using .elf section
 and/or accepts command line arguments.
 .
 For more advanced peripheral and virtual circuitry prototyping and simulation
 see AVR simulator development examples provided by libsimavr-examples package.

Package: libsimavr1
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: AVR simulator shared library
 A library for advanced AVR core and peripheral circuitry prototyping
 including AVR firmware simulated execution, VCD waveform creation and live
 debugging. For more information see virtual circuitry peripheral prototyping
 and simulation examples provided by libsimavr-examples package.
 .
 This package contains shared library providing AVR simulation functionality.

Package: libsimavr-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Suggests: libsimavr-examples, avr-libc, avra
Recommends: build-essential, pkg-config
Depends: ${misc:Depends}, libsimavr1 (= ${binary:Version})
Description: AVR simulator development library
 A library for advanced AVR core and peripheral circuitry prototyping
 including AVR firmware simulated execution, VCD waveform creation and live
 debugging. For more information see virtual circuitry peripheral prototyping
 and simulation examples provided by libsimavr-examples package.
 .
 This package contains software development header files and static library.

Package: libsimavr-examples
Architecture: all
Multi-Arch: foreign
Section: devel
Suggests: arduino, avrdude, avra
Recommends: libsimavr-dev, avr-libc, freeglut3-dev, arduino-core
Depends: ${misc:Depends}
Description: AVR simulator development examples
 A library for advanced AVR core and peripheral circuitry prototyping
 including AVR firmware simulated execution, VCD waveform creation and live
 debugging.
 .
 Tis package contains fully functional virtual circuitry prototyping example
 code for the AVR simulator development library including simulation of
 peripherals attached to simulated AVR microcontroller.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1
#export V=1

PTH  = $(abspath $(dir $(MAKEFILE_LIST)))
VER ?= $(shell dpkg-parsechangelog --file $(PTH)/changelog \
         --show-field version \
         | sed -e "s,\(.*\)-.*,\\1," -e "s,.*:,," -e "s,.dfsg[0-9]*,,")

export DEB_BUILD_MAINT_OPTIONS=hardening=+all
export DEB_CFLAGS_MAINT_APPEND=$(shell getconf LFS_CFLAGS)

MA = /$(shell dpkg-architecture -qDEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_clean:
	rm -f examples.tar
	rm -f debian/examples/board_simduino/ATmegaBOOT_168_atmega328.ihex
	dh_auto_clean

override_dh_auto_build:
	dh_auto_build -- RELEASE=1 SIMAVR_VERSION=$(VER)
	ln -s /usr/share/arduino/hardware/arduino/bootloaders/atmega/ATmegaBOOT_168_atmega328.hex debian/examples/board_simduino/ATmegaBOOT_168_atmega328.ihex
	tar cf examples.tar \
	  --mode=644 \
	  --numeric-owner \
	  --owner=0 \
	  --group=0 \
	  --mtime=./examples/Makefile \
	  --files-from=debian/examples.tarball
	tar rf examples.tar \
	  --numeric-owner \
	  --owner=0 \
	  --group=0 \
	  --mtime=./debian/examples/makefile.common \
	  -C debian examples

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr RELEASE=1 SIMAVR_VERSION=$(VER) MA=$(MA)

override_dh_install:
	dh_install --list-missing

get-orig-source:
	uscan --no-conf \
	  --verbose \
	  --destdir=$(CURDIR) \
	  --rename \
	  --force-download \
	  --download-version $(VER) \
	  --check-dirname-level=0 \
	  $(PTH)

=== debian/watch ===
version=3
opts="compression=xz,repack,repacksuffix=+dfsg1,dversionmangle=s:.dfsg[0-9]*$::" https://github.com/buserror/simavr/releases /buserror/simavr/archive/v?(.+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))

## simavr 1.6%2Bdfsg

=== doc/Makefile ===
#
# 	Copyright 2008, 2009 Michel Pollet <buserror@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

# For the callgraph, you need Graphviz, ruby and exuberant ctags.
# The manual requires latex including additional packages (acronym, graphicx, fancyvrb, ...).
# This is not generated in the normal code build

.PHONY: manual

all:	simavr_callgraph.pdf manual

simavr_callgraph.pdf:
	ctags -f .tags ../simavr/sim/sim_*.[ch] ../simavr/sim/run_*.[ch] 2>/dev/null && \
		ruby ./tags_to_dot.rb .tags \
			../simavr/sim/sim_*.c ../simavr/sim/run_*.c >.tags.dot && \
				dot -Tpdf .tags.dot -o $@

manual:
	$(MAKE) -C manual

clean:
	rm -f .tags*
	$(MAKE) -C manual clean

=== examples/Makefile ===

boards_base=${wildcard board_*}
# Remove simduino until FileMapping is implemented to work around missing mmap in Win32
ifeq (${shell uname -o}, Msys)
boards=${subst board_usb,,${subst board_simduino,,$(boards_base)}}
else
boards=$(boards_base)
endif

all:
	for bi in ${boards}; do $(MAKE) -C $$bi; done

clean:
	for bi in ${boards}; do $(MAKE) -C $$bi clean; done

#
# The USB example is not made by default, as it downloads stuff
# for the vhci library, it fails the debian policy on being able
# to build offline.
#
extra_board_usb:
	make -C extra_board_usb

## simavr 1.6+dfsg

=== Makefile ===
--- 
+++ 
@@ -9,7 +9,7 @@
 
 .PHONY: doc
 
-all:	build-simavr build-tests build-examples
+all:	build-simavr build-tests build-examples build-parts
 
 build-simavr:
 	$(MAKE) -C simavr RELEASE=$(RELEASE)
@@ -20,15 +20,22 @@
 build-examples: build-simavr
 	$(MAKE) -C examples RELEASE=$(RELEASE)
 
+build-parts: build-examples
+	$(MAKE) -C examples/parts RELEASE=$(RELEASE)
+
 install:
 	$(MAKE) -C simavr install RELEASE=$(RELEASE)
 
 doc:
 	$(MAKE) -C doc RELEASE=$(RELEASE)
 
+install:
+	$(MAKE) -C simavr install
+
 clean:
 	$(MAKE) -C simavr clean
 	$(MAKE) -C tests clean
 	$(MAKE) -C examples clean
+	$(MAKE) -C examples/parts clean
 	$(MAKE) -C doc clean

=== simavr/Makefile ===
--- 
+++ 
@@ -18,8 +18,7 @@
 
 SHELL 			:= ${shell which bash}
 SIMAVR_VERSION	:= ${shell \
-	{ git log -1 --tags --simplify-by-decoration --pretty="format:%d"|\
-		sed -e 's/[\(\) ]//g'; } || \
+	git describe --abbrev=0 --tags || \
 	echo "unknown" }
 SIMAVR_REVISION	= 2
 
@@ -51,33 +50,15 @@
 # Static library
 #
 ${OBJ}/libsimavr.a	:	${sim_o}
-ifeq ($(V),1)
-	$(AR) cru $@ $^ && $(RANLIB) $@
-else
-	@echo AR $@
-	@$(AR) cru $@ $^ && $(RANLIB) $@
-endif
 
-#
-# Shared library (Linux)
-#
-${OBJ}/libsimavr.so.1	:	${sim_o}
-ifeq ($(V),1)
-	$(CC) -shared -Wl,-soname,libsimavr.so.1 -o $@ $^ ${filter-out -lsimavr, $(LDFLAGS)}
-else
-	@echo SHARED $@
-	@$(CC) -shared -Wl,-soname,libsimavr.so.1 -o $@ $^ ${filter-out -lsimavr, $(LDFLAGS)}
-endif
-
-${OBJ}/libsimavr.so		: ${OBJ}/libsimavr.so.1
-	ln -sf libsimavr.so.1 $@
 
 libsimavr	: config ${OBJ}/libsimavr.a
 # shared library won't work that easily on non-linux
 ifeq (${shell uname}, Linux)
-libsimavr	:	${OBJ}/libsimavr.so
+libsimavr	: ${OBJ}/libsimavr.so
 endif
 
+${OBJ}/${target}.elf	: libsimavr
 ${OBJ}/${target}.elf	: ${OBJ}/${target}.o
 
 ${target}	: ${OBJ}/${target}.elf
@@ -98,19 +79,26 @@
 
 install : all
 	$(MKDIR) $(DESTDIR)/include/simavr/avr
+	$(MKDIR) $(DESTDIR)/include/simavr/parts
 	$(INSTALL) -m644 sim/*.h $(DESTDIR)/include/simavr/
 	$(INSTALL) -m644 sim_core_*.h $(DESTDIR)/include/simavr/
 	$(INSTALL) -m644 sim/avr/*.h $(DESTDIR)/include/simavr/avr/
+	$(INSTALL) -m644 ../examples/parts/*.h $(DESTDIR)/include/simavr/parts/
 	$(MKDIR) $(DESTDIR)/lib
 	$(INSTALL) ${OBJ}/libsimavr.a $(DESTDIR)/lib/
+	$(INSTALL) ../examples/parts/${OBJ}/libsimavrparts.a $(DESTDIR)/lib/
 	$(MKDIR) $(DESTDIR)/lib/pkgconfig/
 	sed -e "s|PREFIX|${PREFIX}|g" -e "s|VERSION|${SIMAVR_VERSION}|g" \
 		simavr-avr.pc >$(DESTDIR)/lib/pkgconfig/simavr-avr.pc
 	sed -e "s|PREFIX|${PREFIX}|g" -e "s|VERSION|${SIMAVR_VERSION}|g" \
 		simavr.pc >$(DESTDIR)/lib/pkgconfig/simavr.pc
+	sed -e "s|PREFIX|${PREFIX}|g" -e "s|VERSION|${SIMAVR_VERSION}|g" \
+		simavrparts.pc >$(DESTDIR)/lib/pkgconfig/simavrparts.pc
 ifeq (${shell uname}, Linux)
 	$(INSTALL) ${OBJ}/libsimavr.so.1 $(DESTDIR)/lib/
+	$(INSTALL) ../examples/parts/${OBJ}/libsimavrparts.so.1 $(DESTDIR)/lib/
 	ln -sf libsimavr.so.1 $(DESTDIR)/lib/libsimavr.so
+	ln -sf libsimavrparts.so.1 $(DESTDIR)/lib/libsimavrparts.so
 endif
 	$(MKDIR) $(DESTDIR)/bin
 	$(INSTALL) ${OBJ}/${target}.elf $(DESTDIR)/bin/simavr
@@ -165,8 +153,8 @@
 			conf+="#define CONFIG_$$upper 1\n"; \
 			obj=$${file/.c/.o} ; obj=$${obj/cores\/}; \
 			printf "\$${OBJ}/libsimavr.a: \$${OBJ}/$$obj\n">>${OBJ}/cores.deps ; \
-			printf "\$${OBJ}/libsimavr.so.1: \$${OBJ}/$$obj\n">>${OBJ}/cores.deps ; \
 		else \
+			conf+="#undef CONFIG_$$upper\n"; \
 			echo WARNING $$file did not compile, check your avr-gcc toolchain; \
 		fi \
 	done ; \
@@ -188,7 +176,7 @@
 	for core in $$(grep -r avr_kind_t cores/|awk -F '[ :]' '{print $$1 "=" $$3;}') ; do \
 		file=$${core/=*}; global=$${core/*=}; \
 		upper=$$global; upper=$${upper/.c}; \
-		upper=$$(echo $$upper|tr '[a-z]' '[A-Z]'); \
+		upper=$$(echo $$global|tr '[a-z]' '[A-Z]'); \
 		decl+="#if CONFIG_$$upper\nextern avr_kind_t $$global;\n#endif\n"; \
 		array+="#if CONFIG_$$upper\n\t&$$global,\n#endif\n"; \
 	done ; \

=== tests/Makefile ===
#
# This makefile takes each "at*" file, extracts it's part name
# And compiles it into an ELF binary.
# It also disassembles it for debugging purposes.
# 
# 	Copyright 2008-2012 Michel Pollet <buserror@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

sources		:= $(wildcard at*.c)
simavr 		= ..

IPATH 		+= ${simavr}/include
IPATH 		+= ${simavr}/simavr/sim

tests_src	:= ${wildcard test_*.c}

all: obj axf tests

include ../Makefile.common

tests		:= ${patsubst %.c, ${OBJ}/%.tst, ${tests_src}}

tests:	${tests}
	
axf: ${sources:.c=.axf}
	

${OBJ}/%.tst: tests.c %.c
ifeq ($(V),1)
	$(CC) -MMD ${CPPFLAGS} ${CFLAGS} ${LFLAGS} -o $@ ${patsubst %.h,, ${^}} $(LDFLAGS)
else
	@echo TST $@
	@$(CC) -MMD ${CPPFLAGS} ${CFLAGS} ${LFLAGS} -o $@ ${patsubst %.h,, ${^}} $(LDFLAGS)
endif

run_tests: all
	@export LD_LIBRARY_PATH=${simavr}/simavr/${OBJ} ;\
	num_failed=0 ;\
	num_run=0 ;\
	for test in ${OBJ}/test_*.tst; do \
	    num_run=$$(($$num_run+1)) ;\
	    if ! $$test; then \
			echo "$$test returned with exit value $$?." ;\
			num_failed=$$(($$num_failed+1)) ;\
	    fi ;\
	done ;\
	echo "Tests run: $$num_run  Successes: $$(($$num_run-$$num_failed))  Failures: $$num_failed"

clean: clean-${OBJ}
	rm -f *.axf *.vcd

=== examples/board_hd44780/Makefile ===
# 
# 	Copyright 2008-2011 Michel Pollet <buserror@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

target=	charlcd
firm_src = ${wildcard at*${board}.c}
firmware = ${firm_src:.c=.axf}
simavr = ../../

IPATH = .
IPATH += ../parts
IPATH += ${simavr}/include
IPATH += ${simavr}/simavr/sim

VPATH = .
VPATH += ../parts

LDFLAGS += -lpthread

include ../Makefile.opengl

all: obj atmega48_charlcd.axf ${target} 

atmega48_charlcd.axf: atmega48_charlcd.c

include ${simavr}/Makefile.common

board = ${OBJ}/${target}.elf

${board} : ${OBJ}/ac_input.o
${board} : ${OBJ}/hd44780.o
${board} : ${OBJ}/hd44780_glut.o
${board} : ${OBJ}/${target}.o

${target}: ${board}
	@echo $@ done

clean: clean-${OBJ}
	rm -rf *.hex *.a *.axf ${target} *.vcd .*.swo .*.swp .*.swm .*.swn

=== examples/board_i2ctest/Makefile ===
# 
# 	Copyright 2008-2012 Michel Pollet <buserror@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

target=	i2ctest
firm_src = ${wildcard at*${board}.c}
firmware = ${firm_src:.c=.axf}
simavr = ../..

IPATH = .
IPATH += ${simavr}/examples/shared
IPATH += ${simavr}/examples/parts
IPATH += ${simavr}/include
IPATH += ${simavr}/simavr/sim

VPATH = .
VPATH += ${simavr}/examples/shared
VPATH += ${simavr}/examples/parts


all: obj ${firmware} ${target} 

include ${simavr}/Makefile.common

atmega1280_${target}.axf: atmega1280_${target}.c twimaster.c
atmega1280_${target}.axf: ${simavr}/examples/shared/avr_twi_master.c
atmega1280_${target}.axf: ${simavr}/examples/shared/avr_twi_master.h

board = ${OBJ}/${target}.elf

${board} : ${OBJ}/${target}.o
${board} : ${OBJ}/i2c_eeprom.o

${target}: ${board}
	@echo $@ done

clean: clean-${OBJ}
	rm -rf *.hex *.a *.axf ${target} *.vcd .*.swo .*.swp .*.swm .*.swn

=== examples/board_ledramp/Makefile ===
# 
# 	Copyright 2008, 2009 Michel Pollet <buserror@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

target=	ledramp
firm_src = ${wildcard at*${board}.c}
firmware = ${firm_src:.c=.axf}
simavr = ../../

IPATH = .
IPATH += ../parts
IPATH += ${simavr}/include
IPATH += ${simavr}/simavr/sim

VPATH = .
VPATH += ../parts

LDFLAGS += -lpthread

include ../Makefile.opengl

all: obj ${firmware} ${target}

include ${simavr}/Makefile.common

board = ${OBJ}/${target}.elf

${board} : ${OBJ}/button.o
${board} : ${OBJ}/${target}.o

${target}: ${board}
	@echo $@ done

clean: clean-${OBJ}
	rm -rf *.a *.axf ${target} *.vcd *.hex

=== examples/board_simduino/Makefile ===
#
# 	Copyright 2008, 2009 Michel Pollet <buserror@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

target=	simduino
firm_src = ${wildcard atmega*.c}
firmware = ${firm_src:.c=.hex}
simavr = ../../

IPATH = .
IPATH += ../parts
IPATH += ${simavr}/include
IPATH += ${simavr}/simavr/sim

VPATH = .
VPATH += ../parts

LDFLAGS += -lpthread -lutil

include ../Makefile.opengl

all: obj ${firmware} ${target}

include ${simavr}/Makefile.common

board = ${OBJ}/${target}.elf

${board} : ${OBJ}/uart_pty.o
${board} : ${OBJ}/${target}.o

${target}: ${board}
	@echo $@ done

clean: clean-${OBJ}
	rm -rf *.a *.axf ${target} *.vcd *.hex

=== examples/board_timer_64led/Makefile ===
# 
# 	Copyright 2008, 2009 Michel Pollet <buserror@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

target=	timer_64led
firm_src = ${wildcard at*${target}.c}
firmware = ${firm_src:.c=.axf}
simavr = ../../

IPATH = .
IPATH += ../parts
IPATH += ${simavr}/include
IPATH += ${simavr}/simavr/sim

VPATH = .
VPATH += ../parts

LDFLAGS += -lpthread

include ../Makefile.opengl

all: obj ${firmware} ${target}

include ${simavr}/Makefile.common

board = ${OBJ}/${target}.elf

${board} : ${OBJ}/button.o
${board} : ${OBJ}/hc595.o
${board} : ${OBJ}/${target}.o

${target}: ${board}
	@echo $@ done

clean: clean-${OBJ}
	rm -rf *.a *.axf ${target} *.vcd *.hex

=== examples/extra_board_usb/Makefile ===
# 
# 	Copyright 2012 Torbjorn Tyridal <ttyridal@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

target=	simusb
firm_src = at90usb162_cdc_loopback.c
firmware = ${firm_src:.c=.hex}
simavr = ../../

IPATH = .
IPATH += ../parts
IPATH += ../vhci/include
IPATH += ../vhci
IPATH += ${simavr}/include
IPATH += ${simavr}/simavr/sim
#IPATH += /usr/local/include

VPATH = .
VPATH += ../parts

LDFLAGS += -lpthread -lusb_vhci -L../vhci/lib

all: obj ${firmware} ${target}

include ${simavr}/Makefile.common

board = ${OBJ}/${target}.elf

${board} : ${OBJ}/vhci_usb.o
${board} : ${OBJ}/${target}.o

../vhci/lib/libusb_vhci.a:
	@echo -n "BUILDIN $@ "
	@{ export CC=;export CFLAGS=; $(MAKE) -j -C ../vhci >/tmp/vhci.build.log 2>&1 || \
		{ echo "ERROR check /tmp/vhci.build.log"; exit 1; }; } && \
			echo " Done" 

vhci : ../vhci/lib/libusb_vhci.a 

clean-vhci:
	$(MAKE) -C ../vhci clean

${target}: vhci ${board}
	@echo $@ done

clean: clean-${OBJ} clean-vhci
	rm -rf *.a *.axf *.hex ${target} *.vcd

=== examples/parts/Makefile ===
#	Copyright 2014,2017 Doug Szumski <d.s.szumski@gmail.com>
#	Copyright 2008-2011 Michel Pollet <buserror@gmail.com>
#
#	This file is part of simavr.
#
#	simavr is free software: you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation, either version 3 of the License, or
#	(at your option) any later version.
#
#	simavr is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with simavr.  If not, see <http://www.gnu.org/licenses/>.

LDFLAGS += -lpthread
simavr = ../../
IPATH += ${simavr}/simavr/sim

target := libsimavrparts

all: obj ${target}

include ${simavr}/Makefile.common

objects := $(patsubst %.c,${OBJ}/%.o, $(wildcard *.c))

# Unless the VHCI_USB env var is set, don't build this because it requires
# a supporting library to be installed. See examples/extra_board_usb/README
# for details on how to build it.
ifndef VHCI_USB
	objects := $(filter-out %vhci_usb.o, $(objects))
endif

#
# Static library
#
${OBJ}/${target}.a: ${objects}
${target}: ${OBJ}/${target}.a
#
# Shared library (Linux only)
#
ifeq (${shell uname}, Linux)
${target}: ${OBJ}/${target}.so
endif

clean: clean-${OBJ}
	rm -rf *.hex *.a *.axf *.vcd .*.swo .*.swp .*.swm .*.swn *.so *.o

=== examples/vhci/Makefile ===
#
# This makefile attempts to compile the vhci core module and the
# libusb-vhci library by downloading known tarballs, hacking them
# a little and compiling them
# 
# This has been tested on debian, but coild possibly work in other
# distro. the only "real" dependency is to have the linux kernel
# header symlinked at /lib/modules/<your host kernel version/build
#

HCD_V		= 1.14
VHCI_V 		= 0.6
BASE_URL	= http://downloads.sourceforge.net/project/usb-vhci
PWD			= ${shell pwd}

all: library

module: vhci-hcd-$(HCD_V)/usb-vhci-hcd.ko

vhci-hcd-$(HCD_V)/usb-vhci-hcd.ko: vhci-hcd-$(HCD_V)
	$(MAKE) -C vhci-hcd-$(HCD_V) \
		KDIR=/lib/modules/${shell uname -r}/build \
		CORE_INCLUDE_DIR=$(PWD)/vhci-hcd-$(HCD_V)/linux/2.6.32/drivers/usb/core

vhci-hcd-$(HCD_V).tar.bz2: 
	wget $(BASE_URL)/linux%20kernel%20module/$@

vhci-hcd-$(HCD_V): vhci-hcd-$(HCD_V).tar.bz2
	tar jxf $@.tar.bz2 && \
		cd $@ && \
		cat ../patches/hcd-*.patch | patch --merge -p1 
	sed -i -e 's|#define DEBUG|#undef DEBUG|' vhci-hcd-$(HCD_V)/usb-vhci-hcd.c

library: lib/libusb_vhci.a

lib/libusb_vhci.a: module libusb_vhci-$(VHCI_V)
	ln -snf vhci-hcd-$(HCD_V) linux && \
		cd libusb_vhci-$(VHCI_V) && \
		./configure --prefix=$(PWD) CPPFLAGS="-I$(PWD)" --enable-static --disable-shared && \
			$(MAKE) -j && $(MAKE) install

libusb_vhci-$(VHCI_V).tar.bz2:
	wget $(BASE_URL)/native%20libraries/libusb_vhci-$(VHCI_V).tar.bz2

libusb_vhci-$(VHCI_V): libusb_vhci-$(VHCI_V).tar.bz2
	tar jxf $@.tar.bz2 && \
		cd $@ && \
		cat ../patches/vhci-*.patch | patch --merge -p1 

clean:
	rm -rf libusb_vhci-$(VHCI_V) vhci-hcd-$(HCD_V) lib include linux

distclean: clean
	rm -rf *.tar.bz2

=== debian/changelog ===
simavr (1.6+dfsg-3) sid; urgency=medium

  * ensure proper C string null termination (closes: #925828)
  * bump standards version up to 4.4.0

 -- Milan Kupcevic <milan@debian.org>  Wed, 28 Aug 2019 23:59:06 -0400

simavr (1.6+dfsg-2) sid; urgency=medium

  [ Ondřej Nový ]
  * d/control: Remove trailing whitespaces

  [ Piper McCorkle ]
  * Change gtkwave to suggested (Closes: #912264)

 -- Milan Kupcevic <milan@debian.org>  Mon, 11 Mar 2019 13:58:08 -0400

simavr (1.6+dfsg-1) sid; urgency=medium

  * new upstream release
  * debian/copyright: update
  * rebuild reproducible docs
  * update git tag version number removal
  * bump ABI version up, set soname to libsimavr.so.2
  * produce libsimavrparts1, a new library package
  * update simavr man page
  * fix examples tarball paths and filenames
  * correct spelling mistakes
  * bump standards version up to 4.1.4

 -- Milan Kupcevic <milan@debian.org>  Sun, 24 Jun 2018 20:37:24 -0400

simavr (1.5+dfsg1-3) sid; urgency=medium

  * debian/control: switch git repository to salsa.debian.org
  * debian/rules: improve umask variation reproducibility (closes: #883244)

 -- Milan Kupcevic <milan@debian.org>  Tue, 10 Apr 2018 23:00:43 -0400

=== debian/control ===
--- 
+++ 
@@ -9,21 +9,22 @@
  pkg-config,
  avr-libc,
  ruby,
+ ghostscript,
  exuberant-ctags,
  graphviz
-Standards-Version: 4.1.1
-Vcs-Git: https://gitlab.com/debian/simavr.git
-Vcs-Browser: https://gitlab.com/debian/simavr.git
+Standards-Version: 4.4.0
+Vcs-Git: https://salsa.debian.org/debian/simavr.git
+Vcs-Browser: https://salsa.debian.org/debian/simavr
 Homepage: https://github.com/buserror/simavr
 
 Package: simavr
 Architecture: any
 Multi-Arch: foreign
-Recommends: gtkwave, gdb-avr
-Suggests: avr-libc, avra, libsimavr-dev
+Recommends: gdb-avr
+Suggests: gtkwave, avr-libc, avra, libsimavr-dev
 Depends: ${shlibs:Depends}, ${misc:Depends}
 Description: lean and mean AVR simulator
- A simple command line tool using AVR simulator library to run AVR firmware, 
+ A simple command line tool using AVR simulator library to run AVR firmware,
  produce VCD waveform files and/or run a debugging session. The tool reads
  simulation parameters directly from the emulated code using .elf section
  and/or accepts command line arguments.
@@ -31,7 +32,7 @@
  For more advanced peripheral and virtual circuitry prototyping and simulation
  see AVR simulator development examples provided by libsimavr-examples package.
 
-Package: libsimavr1
+Package: libsimavr2
 Architecture: any
 Multi-Arch: same
 Section: libs
@@ -45,13 +46,28 @@
  .
  This package contains shared library providing AVR simulation functionality.
 
+Package: libsimavrparts1
+Architecture: any
+Multi-Arch: same
+Section: libs
+Depends: ${shlibs:Depends}, ${misc:Depends}
+Pre-Depends: ${misc:Pre-Depends}
+Description: AVR simulator additional peripherals shared library
+ A library for advanced AVR core and peripheral circuitry prototyping
+ including AVR firmware simulated execution, VCD waveform creation and live
+ debugging. For more information see virtual circuitry peripheral prototyping
+ and simulation examples provided by libsimavr-examples package.
+ .
+ This package contains shared library providing additional peripherals.
+
 Package: libsimavr-dev
 Architecture: any
 Multi-Arch: same
 Section: libdevel
 Suggests: libsimavr-examples, avr-libc, avra
 Recommends: build-essential, pkg-config
-Depends: ${misc:Depends}, libsimavr1 (= ${binary:Version})
+Depends: ${misc:Depends}, libsimavr2 (= ${binary:Version}),
+ libsimavrparts1 (= ${binary:Version})
 Description: AVR simulator development library
  A library for advanced AVR core and peripheral circuitry prototyping
  including AVR firmware simulated execution, VCD waveform creation and live
@@ -72,6 +88,6 @@
  including AVR firmware simulated execution, VCD waveform creation and live
  debugging.
  .
- Tis package contains fully functional virtual circuitry prototyping example
+ This package contains fully functional virtual circuitry prototyping example
  code for the AVR simulator development library including simulation of
- peripherals attached to simulated AVR microcontroller.  
+ peripherals attached to simulated AVR microcontroller.

=== debian/rules ===
--- 
+++ 
@@ -22,19 +22,21 @@
 	dh_auto_clean
 
 override_dh_auto_build:
-	dh_auto_build -- RELEASE=1 SIMAVR_VERSION=$(VER)
+	dh_auto_build -- RELEASE=1 SIMAVR_VERSION=$(VER) all doc
 	ln -s /usr/share/arduino/hardware/arduino/bootloaders/atmega/ATmegaBOOT_168_atmega328.hex debian/examples/board_simduino/ATmegaBOOT_168_atmega328.ihex
 	tar cf examples.tar \
 	  --mode=644 \
 	  --numeric-owner \
 	  --owner=0 \
 	  --group=0 \
+	  --mode=go=rX,u+rw,a-s \
 	  --mtime=./examples/Makefile \
 	  --files-from=debian/examples.tarball
 	tar rf examples.tar \
 	  --numeric-owner \
 	  --owner=0 \
 	  --group=0 \
+	  --mode=go=rX,u+rw,a-s \
 	  --mtime=./debian/examples/makefile.common \
 	  -C debian examples

=== debian/watch ===
version=3
opts="compression=xz,repack,repacksuffix=+dfsg,dversionmangle=s:.dfsg[0-9]*$::" https://github.com/buserror/simavr/releases /buserror/simavr/archive/v?(.+)\.(?:tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
